
/**
 * addParam(applet, name, value) adds a param tag to the applet specefied.
 * The name attribute of the tag is name.
 * The value attribute of the tag is value.
 */
function addParam(applet, name, value){
  if(applet.loaded){
    alert(applet.className + ": too late for addParam().");
    return;
  }
  var param = document.createElement("param");
  param.setAttribute("name", name);
  param.setAttribute("value", value);
  applet.appendChild(param);
}

/**
 * loadApplet(applet, code, codebase, archive) loads the applet.
 * The code parameter specifies the Java class of the applet.
 * The codebase parameter specifies the location of the directory
 * containing the class file or archive (jar file).
 * The archive file specefies the jar.
 */
function loadApplet(applet, code, codebase, archive) {
  if (applet.loaded) {
    alert(applet.className + " has already been loaded.");
    return;
  }
  if (arguments.length > 2) {
    addParam(applet, "codebase", codebase);
  } else {
    addParam(applet, "codebase", ".");
  }
  if (arguments.length > 3) {
    addParam(applet, "archive", archive);
  }
  addParam(applet, "code", code);
  document.body.appendChild(applet);
  applet.loaded = true;
}

ObjectLoader = {
  // FIXME - need to cope with deferred loads.
  loadFunctions: [],
  load: function(objectElement) {
    var className = objectElement.className;
    var url = new URL(objectElement.data);
    var loadFunction = this.loadFunctions[className];
    if (loadFunction) {
      var replacement = loadFunction(url);
    } else {
      replacement = DOM.createErrorElement("object", url, "unknown class");
    }
    var parent = objectElement.getParentNode();
    DOM.replaceChild(parent, objectElement, replacement, "ObjectLoader.load")
  }
};
ObjectLoader.loadFunctions["include"] = function(url) {
  // get an element from the repository and return it
  };
ObjectLoader.loadFunctions["applet"] = function(url) {
  var context = {
    url: src,
    callback: function(con) {
      if (con.status == 200) {
        var appletDescriptor = con.responseXML.documentElement;
        var code = appletDescriptor.getAttribute("class");
        var archive = appletDescriptor.getAttribute("jar");
        var height = appletDescriptor.getAttribute("height");
        var width = appletDescriptor.getAttribute("width");
        var codeBase = appletDescriptor.getAttribute("dir");
        if(codeBase == null){
          codeBase = ".";
        }
        var applet = document.createElement("object");
        addParam(applet, "pluginspage",
          "http://java.sun.com/products/plugin/1.5/plugin-install.html");
        var children = appletDescriptor.childNodes;
        for (var i = 0; i < children.length; i++) {
          var parameter = children.item(i);
          // FIXME - check to see if it really is a param element.
          // If it is can we just import it?
          if (parameter == "[object Element]") {
            var name = parameter.getAttribute("name");
            var type = parameter.getAttribute("value");
            addParam(applet, name, type);
          }
        }
        this.applet = applet;
        applet.type = "application/x-java-applet;version=1.5";
        applet.width = width;
        applet.height = height;
        applet.loaded = false;
        loadApplet(applet, code, codeBase, archive);
      } else {
        // FIXME - need to reate an error element and install it.
        alert("Unable to load from url " + src + ".");
      }
    }
  };
  Loader.loadHTTP(context);
};
ObjectLoader.loadFunctions["image"] = function(url) {
  // return an object element for the image using the
  // url suffix to determine the image type
  };
