
function alertForListElement(listElement) {
  var message = "List element\n";
  var children = listElement.childNodes;
  for (var i = 0; i < children.length; i++) {
    var child = children.item(i);
    var textNode = child.firstChild;
    message += "  " + textNode.data + "\n";
  }
  alert(message);
}

function createListElement(list) {
  var items = list.childNodes;
  var listElement = document.createElement("ul");
  for (var i = 0; i < items.length; i++) {
    var item = items.item(i);
    if (item.tagName == "item") {
      var itemElement = document.createElement("li");
      var url = item.getAttribute("url");
//      alert("item url = " + url);
      var itemTextNode = document.createTextNode(url);
      itemElement.appendChild(itemTextNode);
      listElement.appendChild(itemElement);
    }
  }
//  alertForListElement(listElement);
  return listElement;
}

function createParagraph(text) {
  var paragraphElement = document.createElement("p");
  paragraphElement.appendChild(document.createTextNode(text));
  return paragraphElement;
}

function showAllLists(src) {
  var context = {
    url: src,
    callback: function(con) {
      if (con.status == 200) {
        var documentElement = con.responseXML.documentElement;
        var children = documentElement.childNodes;
        for (var i = 0; i < children.length; i++) {
          var list = children.item(i);
          if (list.tagName == "list") {
//            alert("list type = " + list.getAttribute("type"));
            var paragraphElement = createParagraph(list.getAttribute("type"));
            document.body.appendChild(paragraphElement);
            var listElement = createListElement(list);
            document.body.appendChild(listElement);
//            alert("list added to document.")
          }
        }
      } else {
        alert("Unable to load from url " + src + ".");
      }
    }
  };
  Loader.loadHTTP(context);
}
